<template>
  <div >
    <ApplyLeave
      v-bind.sync="leave"
      v-on:submit="submit"
      v-on:cancel="cancel"
      v-bind:loading="loading"
    >
    </ApplyLeave>
  </div>
</template>

<script>

import ApplyLeave from '@/components/employeePanel/ApplyLeave.vue';
import { getAuthenticatedUser } from '@/fb';
// import Logger from '@/logger/index';
import { mapGetters } from 'vuex';
import Leave from '@/models/ApplyLeave';

export default {
  components: {
    ApplyLeave,
  },
  data() {
    return {
      leave: new Leave(),
      loading: false,
    };
  },
  props: {
    id: {
      type: String,
      required: true,
    },
  },
  created() {
    console.log('hello this is id ', this.id);
  },
  computed: {
    ...mapGetters({
      snackbarText: 'getSnackbarText',
      showSnackbar: 'getShowSnackbar',
      user: 'getUser',
    }),
  },
  mounted() {
    getAuthenticatedUser().then((user) => {
      this.leave.uid = user.uid;
      this.leave.id = this.id;
      console.log('this is note ID', this.leave.id);
      this.leave.fetch();
    });
  },
  methods: {
    submit() {
      this.loading = true;
      this.leave.update().then(() => {
        console.log('Done creating note', this.leave.id);
        this.$store.dispatch('setSnackbarText', 'Updating leave list');
        this.$store.dispatch('setShowSnackbar', true);
        this.loading = false;
        this.$router.replace({ name: 'Employeeleave' });
      });
    },
    cancel() {
      this.$router.replace({ name: 'Employeeleave' });
    },
  },
};
</script>
